#include <stdlib.h>
#include <stdio.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "config.h"

#include "lcd.h"
#include "sdkarte/fat16.h"
#include "sdkarte/sdcard.h"
#include "mem-check.h"

#if USE_MCA25_CAM
  #include "camera/mca25.h"
#endif

int bufferlen=512;
char buffer[512]="asdfghjkl";
char membuffer[10];

int main(void)
{
	#if USE_SER_LCD
	lcd_init();
	lcd_clear();
	back_light = 10;
	#endif

	#if USE_MMC
		f16_init();
		f16_check();	// Ein-/Ausstecken der SD-Karte erkennen
		mca25_cam_status = MCA25_FIRST_DATA;
	#endif

	lcd_print(0,0,"unused mem: ");
	itoa(get_mem_unused(),membuffer,10);
	lcd_print_str(membuffer);

	lcd_print(2,0,"Kamera starten");
	mca25_init();
	lcd_print(3,0,"init ");
	mca25_configure();
	lcd_print(3,0,"conf ");

	if(cwdir_ptr){	//falls SD-Karte vorhanden

		File *picfile = f16_open("camera.jpg","a");
		lcd_print(3,0,"open ");

		f16_fseek(picfile,0,0);		//Schreibposition auf Dateianfang
		lcd_print(3,0,"start");

/*		while (mca25_copy_image_data_to_file_buffer(buffer)){
			fat16_write_file(picfile, (uint8_t *)&buffer[0], bufferlen);
		}*/

		mca25_copy_image_data_to_file_buffer(buffer);	//Cam auslesen
		fat16_write_file(picfile, (uint8_t *)&buffer[0], bufferlen);	//Daten auf Karte schreiben

		lcd_print(3,0,"close");
		f16_close(picfile);
		lcd_print(2,0,"Karte geschrieben");
	}

	lcd_print(3,0,"while");
	while(1)
	{
		#if USE_MMC
			f16_check();	// Ein-/Ausstecken der SD-Karte erkennen
		#endif
	}

	return(0);
}
